package xc

// 缓动_Linear, 线性.
//
// p: 位置, 0.0f - 1.0f.
func XEase_Linear(p float32) float32 {
	_, r, _ := xEase_Linear.Call(Float32Ptr(p))
	return UintPtrToFloat32(r)
}

// 缓动_Quad, 二次方曲线.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Quad(p float32, flag int) float32 {
	_, r, _ := xEase_Quad.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Cubic, 三次方曲线, 圆弧.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Cubic(p float32, flag int) float32 {
	_, r, _ := xEase_Cubic.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Quart, 四次方曲线.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Quart(p float32, flag int) float32 {
	_, r, _ := xEase_Quart.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Quint, 五次方曲线.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Quint(p float32, flag int) float32 {
	_, r, _ := xEase_Quint.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Sine, 正弦曲线, 在末端变化.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Sine(p float32, flag int) float32 {
	_, r, _ := xEase_Sine.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Expo, 突击曲线, 突然一下.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Expo(p float32, flag int) float32 {
	_, r, _ := xEase_Expo.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Circ, 圆环, 好比绕过一个圆环.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Circ(p float32, flag int) float32 {
	_, r, _ := xEase_Circ.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Elastic, 强力回弹.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Elastic(p float32, flag int) float32 {
	_, r, _ := xEase_Elastic.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Back, 回弹, 比较缓慢.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Back(p float32, flag int) float32 {
	_, r, _ := xEase_Back.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_Bounce, 弹跳, 模拟小球落地弹跳.
//
// p: 位置, 0.0f - 1.0f.
//
// flag: 缓动类型, Ease_Type_.
func XEase_Bounce(p float32, flag int) float32 {
	_, r, _ := xEase_Bounce.Call(Float32Ptr(p), uintptr(flag))
	return UintPtrToFloat32(r)
}

// 缓动_扩展, 全部缓动类型.
//
// pos: 位置, 0.0f - 1.0f.
//
// flag: 缓动标识, Ease_Flag_.
func XEase_Ex(pos float32, flag int) float32 {
	_, r, _ := xEase_Ex.Call(Float32Ptr(pos), uintptr(flag))
	return UintPtrToFloat32(r)
}
